
import main_functions_turing_cue_words
from main_functions_turing_cue_words import *

"""
gpt2
"""
guess_words_gpt2, word_list_gpt2, embeddings_gpt2, indices, pairs = from_scratch_to_guess(model_name = 'gpt2', 
                                                                                   distance_type='euclidian')
np.save(save_path + os.sep + 'gpt2_guess_results.npy', {'guess_words':guess_words_gpt2, 'word_list':word_list_gpt2, 'cue_words':cue_words_list, 'embedding': embeddings_gpt2, 'indices':indices, 'pairs':pairs})
df_pairs = pd.DataFrame(columns=['Cue Words','Guess Words'], data = np.array(pairs))
df_pairs.to_csv(save_path + os.sep +'df_pairs_gpt2.csv')

"""
word2vec
"""
guess_words_word2vec, word_list_word2vec, embeddings_word2vec, indices, pairs = from_scratch_to_guess(model_name = 'word2vec', 
                                                                                   distance_type='euclidian')
np.save(save_path + os.sep + 'word2vec_guess_results.npy', {'guess_words':guess_words_gpt2, 'word_list':word_list_gpt2, 'cue_words':cue_words_list, 'embedding': embeddings_gpt2, 'indices':indices, 'pairs':pairs})
df_pairs = pd.DataFrame(columns=['Cue Words','Guess Words'], data = np.array(pairs))
df_pairs.to_csv(save_path + os.sep +'df_pairs_word2vec.csv')



guess_words_gpt2, word_list_gpt2, embeddings_gpt2, indices = from_scratch_to_guess(model_name = 'gpt3', 
                                                                                   distance_type='euclidian')




"""
Prompt GPT3
"""
"""
Option 1:
"""
# dict_davinci_assoc, dict_davinci_back, df_assoc, dict_davinci_assoc_short, dict_davinci_back_short, df_assoc_short = run_prompt_associations(model_name = "text-davinci-002" , num_cues = 3, back_per_cue = 3,
#                             num_associations = 0, 
#                             params_dict = {'temperature' : 0.5,'max_tokens' : 60,'top_p' : 1.0, 'frequency_penalty' : 0.5, 'presence_penalty' : 0.0, 'max_tokens':3})                               

# #np.save(path_save_gpt3_associations + os.sep + model_name + '_associations.npy', dict_davinci_assoc)     
# #np.save(path_save_gpt3_associations + os.sep + model_name + '_back.npy', dict_davinci_back)    
# np.save(save_path + os.sep + 'word2vec_guess_results.npy', {'guess_words':guess_words_gpt2, 'word_list':word_list_gpt2, 'cue_words':cue_words_list, 'embedding': embeddings_gpt2, 'indices':indices, 'pairs':pairs})
# df_assoc.to_csv(save_path + os.sep +'df_pairs_gpt3_prompt_davinci.csv')

# dict_curie_assoc, dict_curie_back, df_assoc, dict_curie_assoc_short, dict_curie_back_short, df_assoc_short = run_prompt_associations(model_name = "text-curie-002" , num_cues = 3, back_per_cue = 3,
#                             num_associations = 0, 
#                             params_dict = {'temperature' : 0.5,'max_tokens' : 60,'top_p' : 1.0, 'frequency_penalty' : 0.5, 'presence_penalty' : 0.0, 'max_tokens':3})                               

# #np.save(path_save_gpt3_associations + os.sep + model_name + '_associations.npy', dict_curie_assoc)     
# #np.save(path_save_gpt3_associations + os.sep + model_name + '_back.npy', dict_curie_back)    
# np.save(save_path + os.sep + 'word2vec_guess_results.npy', {'guess_words':guess_words_gpt2, 'word_list':word_list_gpt2, 'cue_words':cue_words_list, 'embedding': embeddings_gpt2, 'indices':indices, 'pairs':pairs})
# df_assoc.to_csv(save_path + os.sep +'df_pairs_gpt3_prompt_curie.csv')

"""
Option 2
"""
pairs = pd.read_csv('from_sep_30_files/text-davinci-002_no_stop_words_no_short_words_associations.csv').T.reset_index()
pairs.columns = ['Cue Words','Guess Words']
df_pairs.to_csv(save_path + os.sep +'df_pairs_gpt3_davinci_prompt.csv')



concat_names_list = ['df_pairs_word2vec.csv','df_pairs_gpt2.csv','df_pairs_gpt3.csv','df_pairs_gpt3_curie_prompt.csv','df_pairs_gpt3_davinci_prompt.csv']
concat_titles = ['word2vec','gpt2',' gpt3 (embedding)','gpt3 (prompt curie)', 'gpt3 (prompt davinvci)']
def concat_names(concat_names_list, concat_titles):
    dfs = [pd.read_csv(save_path + os.sep +name).T for name in concat_names_list]
    [print(df.shape) for df in dfs]
    concat_df = pd.concat([pd.read_csv(save_path + os.sep +name).set_index('Cue Words')[['Guess Words']] for name in concat_names_list], axis = 1)
    #concat_df = concat_df.T
    concat_df.columns = concat_titles
    
    concat_df.to_csv(save_path + os.sep + 'df_pairs_all_models.csv')
    return concat_df
    
