
import main_functions_turing_cue_words
from main_functions_turing_cue_words import *
k = 50
plural_same = True
lowercase = True
no_prep = True
remove_one_letter = True # removes words with only one letter

if no_prep:   stop_words = list(get_stop_words('en'))         #Have around 900 stopwords
selected_cat = ['JJ','NN','VB']
num_per_cat_full = 100
num_per_cat = 12
min_freq_guess = 1e-15
interval = 50
n_groups = 50
total_words = 200
save_path = r'./from_sep_30_files'
import os
os.makedirs(save_path, exist_ok=True)


"""
Defining the 
"""
dict_taken_from_bin, dict_taken_from_bin_dfs, dict_per_cat_full = from_english_words_to_dict_dfs_freq()

np.save(save_path + os.sep + 'dict_categorize_all_words_and_freq_cue.npy', dict_per_cat_full)
[dict_per_cat_full[cat].to_csv(save_path + os.sep + 'df_all_poassible_cue_words_for_%s.csv'%cat) for cat in dict_per_cat_full.keys()];
over_cat = pd.DataFrame(dict_taken_from_bin)
over_cat.to_csv(save_path + os.sep +'cue_words_selected_bins_over_category.csv')
np.save(save_path + os.sep +'cue_words_selected_bins_over_category_npy.npy',dict_taken_from_bin)
word_lists_per_cat = {cat:dict_per_cat_full[cat]['word'].values for cat in selected_cat}
np.save(save_path + os.sep +'all_possible_words_with_cat_dict.npy',word_lists_per_cat)
word_lists_all_words_lists = np.array(lists2list([df['word'].values for _,df in dict_per_cat_full.items()]))
np.save(save_path + os.sep +'all_possible_words_guess_or_cue.npy',word_lists_all_words_lists)

concat_dict_per_cat_full = pd.concat(dict_per_cat_full)
#concat_dict_per_cat_full['freq'] = 
put_inside_freq  = []
for f in concat_dict_per_cat_full['freq'].values:
    try:
        f_float = f.astype(float)
    except:
        f_float = 0.0
    put_inside_freq.append(f_float)# put_inside_freq
concat_dict_per_cat_full['freq'] = np.array(put_inside_freq).astype(float)    
all_possible_words_and_freqs = concat_dict_per_cat_full.reset_index().groupby(['word','cat']).sum().reset_index()
all_possible_words_and_freqs.to_csv(save_path + os.sep +'all_possible_words_and_freqs.csv')


"""
All CUE words october 1
"""
all_cue_words_oct1 = np.array(lists2list([list_word_in_cat for key, list_word_in_cat in dict_taken_from_bin.items()]))
all_cue_words_oct1[all_cue_words_oct1 == 'fell'] = 'fall'
np.save(save_path + os.sep +'all_cue_words_october_1.npy', all_cue_words_oct1)
#all_cue_words_oct1 = np.load(save_path + os.sep +'all_cue_words_october_1.npy')



"""
All CUE words october 1 - save a dictionary where the cue word is the key and the val is its category
"""
dictionary_cue_word_is_key_val_is_its_category = {}
for key, list_word_in_cat in dict_taken_from_bin.items():
    for w in list_word_in_cat:
        if w == 'fell': w = 'fall'
        dictionary_cue_word_is_key_val_is_its_category[w] = key
np.save(save_path + os.sep +'all_cue_words_october_1_dict_cue_is_key_cat_is_val.npy', dictionary_cue_word_is_key_val_is_its_category)        
        
#all_cue_words_oct1 = np.load(save_path + os.sep +'all_cue_words_october_1.npy')